<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditTourImGroupTypeRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="一级类型" prop="TourImGroupType.parentId">
              <el-cascader
                class="input-item"
                v-model="parentIdPath"
                :options="parentIdWidgetDropdownList"
                placeholder=""
                :clearable="true"
                :filterable="true"
                :show-all-levels="false"
                :props="{ value: 'id', label: 'name', children: 'children', checkStrictly: true }"
                @change="onParentIdValueChange"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="二级类型" prop="TourImGroupType.typeName">
              <el-input
                class="input-item"
                v-model="formData.TourImGroupType.typeName"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="类型图标" prop="TourImGroupType.typeIcon">
              <custom-upload
                v-model="typeIconWidgetFileList"
                name="uploadFile"
                :size="layoutStore.defaultFormItemSize"
                type="expand"
                :headers="getUploadHeaders"
                :action="getUploadActionUrl('/admin/app/tourImGroupType/upload')"
                :data="{fieldName: 'typeIcon', asImage: true}"
                :limit="typeIconWidgetMaxCount"
                @change="onTypeIconChange"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="是否启用 " prop="TourImGroupType.enable">
              <el-select
                class="input-item"
                v-model="formData.TourImGroupType.enable"
                placeholder=""
                :clearable="true"
                :filterable="true"
                @visible-change="enableWidget.onVisibleChange"
              >
                <el-option
                  v-for="item in enableWidgetDropdownList"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitTourImGroupTypeClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditTourImGroupType',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourImGroupTypeData } from '@/api/generated/tourImGroupTypeController';
import { TourImGroupTypeController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditTourImGroupTypeRef = ref();
// 表单数据定义
type FormEditTourImGroupTypeData = {
  TourImGroupType: TourImGroupTypeData;
};
// 表单数据
const formData = reactive<FormEditTourImGroupTypeData>({
  TourImGroupType: {
    // id
    id: undefined,
    // 父级id
    parentId: undefined,
    // 类型名称
    typeName: undefined,
    // 类型图标
    typeIcon: undefined,
    // 是否启用 0否 1是
    enable: undefined,
    // 删除标记 1正常 -1删除
    dataState: undefined,
    // 创建人id
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新时间
    updateTime: undefined,
    // 更新人id
    updateUserId: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourImGroupType.enable': [
  ],
  'TourImGroupType.parentId': [
  ],
  'TourImGroupType.typeIcon': [
  ],
  'TourImGroupType.typeName': [
    {required: true, message: '请输入二级类型', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourImGroupTypeData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourImGroupType = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourImGroupTypeController.view(params).then(res => {
      formData.TourImGroupType = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 一级类型下拉数据获取函数
 */
const loadParentIdDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    const params = {
    };
    DictionaryController.dictTourImGroupType(params).then(res => {
      resolve({
        dataList: res.getList(),
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 一级类型选中值改变
 */
const onParentIdValueChange = (value) => {
  formData.TourImGroupType.parentId = Array.isArray(value) ? value[value.length - 1] : value;
};
// 一级类型配置参数
const parentIdOptions: DropdownOptions<DictData> = {
  loadData: loadParentIdDropdownList,
  isTree: true,
};
// 一级类型选中数据
const parentIdPath = ref<Array<string | number>>([]);
// 一级类型下拉组件
const parentIdWidget = useDropdown(parentIdOptions);
const { dropdownList: parentIdWidgetDropdownList } = parentIdWidget
/**
 * 类型图标上传文件改变
 */
const onTypeIconChange = val => {
  formData.TourImGroupType.typeIcon = fileListToJson(val);
};
// 类型图标上传文件组件
const typeIconWidget = useUploadWidget(1);
const { fileList: typeIconWidgetFileList, maxCount: typeIconWidgetMaxCount } = typeIconWidget;
/**
 * 是否启用 下拉数据获取函数
 */
const loadEnableDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用 配置参数
const enableOptions: DropdownOptions<DictData> = {
  loadData: loadEnableDropdownList,
  isTree: false,
};
// 是否启用 下拉组件
const enableWidget = useDropdown(enableOptions);
const { dropdownList: enableWidgetDropdownList } = enableWidget
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditTourImGroupType = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditTourImGroupType = () => {
  refreshFormEditTourImGroupType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditTourImGroupType();
};
/**
 * 保存
 */
const onSubmitTourImGroupTypeClick = () => {
  formEditTourImGroupTypeRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.TourImGroupType
      };
    retFormData.parentIdDictMap = findTreeNode(parentIdWidgetDropdownList.value, retFormData.parentId, 'id');
    retFormData.enableDictMap = findItemFromList(enableWidgetDropdownList.value, retFormData.enable, 'id');
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      tourImGroupTypeDto: {
        id: formData.TourImGroupType.id,
        parentId: formData.TourImGroupType.parentId,
        typeName: formData.TourImGroupType.typeName,
        typeIcon: formData.TourImGroupType.typeIcon,
        enable: formData.TourImGroupType.enable,
        createUserId: formData.TourImGroupType.createUserId,
        createTime: formData.TourImGroupType.createTime,
        updateTime: formData.TourImGroupType.updateTime,
        updateUserId: formData.TourImGroupType.updateUserId,
      }
    };

    let httpCall = isEdit.value ? TourImGroupTypeController.update : TourImGroupTypeController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourImGroupTypeData().then(res => {
    parentIdWidget.onVisibleChange(true).then(res => {
      // TODO: 获取级联选中路径
      parentIdPath.value = findTreeNodePath(res, formData.TourImGroupType.parentId);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
    let typeIconDownloadParams = {
      id: formData.TourImGroupType.id,
      fieldName: 'typeIcon',
      asImage: true
    };
    typeIconWidgetFileList.value = parseUploadData(formData.TourImGroupType.typeIcon, typeIconDownloadParams);
    enableWidget.onVisibleChange(true).catch(e => {console.error(e)});
    if (isEdit.value) refreshFormEditTourImGroupType();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
